/*************************************************************************
 *
 *	$RCSfile$
 *
 *	$Revision$
 *
 *	last change: $Author$ $Date$
 *
 *	The Contents of this file are made available subject to the terms of
 *	either of the following licenses
 *
 *		   - GNU Lesser General Public License Version 2.1
 *		   - Sun Industry Standards Source License Version 1.1
 *
 *	Sun Microsystems Inc., October, 2000
 *
 *	GNU Lesser General Public License Version 2.1
 *	=============================================
 *	Copyright 2000 by Sun Microsystems, Inc.
 *	901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *	This library is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU Lesser General Public
 *	License version 2.1, as published by the Free Software Foundation.
 *
 *	This library is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *	Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with this library; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *	MA	02111-1307	USA
 *
 *
 *	Sun Industry Standards Source License Version 1.1
 *	=================================================
 *	The contents of this file are subject to the Sun Industry Standards
 *	Source License Version 1.1 (the "License"); You may not use this file
 *	except in compliance with the License. You may obtain a copy of the
 *	License at http://www.openoffice.org/license.html.
 *
 *	Software provided under this License is provided on an "AS IS" basis,
 *	WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *	WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *	MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *	See the License for the specific provisions governing your rights and
 *	obligations concerning the Software.
 *
 *	The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *	Copyright: 2000 by Sun Microsystems, Inc.
 *
 *	All Rights Reserved.
 *
 *	Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

extern "C"
{

    XMLSEC_CRYPTO_EXPORT xmlSecKeysMngrPtr
    xmlSecNssAppliedKeysMngrCreate(
        PK11SlotInfo* slot ,
        CERTCertDBHandle* handler
    ) ;

    XMLSEC_CRYPTO_EXPORT int
    xmlSecNssAppliedKeysMngrSymKeyLoad(
        xmlSecKeysMngrPtr       mngr ,
        PK11SymKey*                     symKey
    ) ;

    XMLSEC_CRYPTO_EXPORT int
    xmlSecNssAppliedKeysMngrPubKeyLoad(
       xmlSecKeysMngrPtr       mngr ,
       SECKEYPublicKey*        pubKey
    ) ;

    XMLSEC_CRYPTO_EXPORT int
    xmlSecNssAppliedKeysMngrPriKeyLoad(
       xmlSecKeysMngrPtr       mngr ,
       SECKEYPrivateKey*       priKey
    ) ;

#define xmlSecNssKeySlotListId xmlSecNssKeySlotListGetKlass()
XMLSEC_CRYPTO_EXPORT xmlSecPtrListId xmlSecNssKeySlotListGetKlass( void ) ;

/*******************************************
 * KeySlot interfaces
 *******************************************/ 
/**
 * Internal NSS key slot data
 * @mechanismList:		the mechanisms that the slot bound with.
 * @slot:				the pkcs slot
 *
 * This context is located after xmlSecPtrList
 */
typedef struct _xmlSecNssKeySlot	xmlSecNssKeySlot ;
typedef struct _xmlSecNssKeySlot*	xmlSecNssKeySlotPtr ;

struct _xmlSecNssKeySlot {
	CK_MECHANISM_TYPE_PTR	mechanismList ; /* mech. array, NULL ternimated */
	PK11SlotInfo*			slot ;
} ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotSetMechList(
	xmlSecNssKeySlotPtr keySlot ,
	CK_MECHANISM_TYPE_PTR mechanismList
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotEnableMech(
	xmlSecNssKeySlotPtr keySlot ,
	CK_MECHANISM_TYPE mechanism
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotDisableMech(
	xmlSecNssKeySlotPtr keySlot ,
	CK_MECHANISM_TYPE mechanism
) ;

XMLSEC_CRYPTO_EXPORT CK_MECHANISM_TYPE_PTR
xmlSecNssKeySlotGetMechList(
    xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotSetSlot(
    xmlSecNssKeySlotPtr keySlot ,
	PK11SlotInfo* slot
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotInitialize(
    xmlSecNssKeySlotPtr keySlot ,
	PK11SlotInfo* slot
) ;

XMLSEC_CRYPTO_EXPORT void
xmlSecNssKeySlotFinalize(
    xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT PK11SlotInfo*
xmlSecNssKeySlotGetSlot(
	xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT xmlSecNssKeySlotPtr
xmlSecNssKeySlotCreate() ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotCopy(
	xmlSecNssKeySlotPtr newKeySlot ,
	xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT xmlSecNssKeySlotPtr
xmlSecNssKeySlotDuplicate(
	xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT void
xmlSecNssKeySlotDestroy(
	    xmlSecNssKeySlotPtr keySlot
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotBindMech(
	xmlSecNssKeySlotPtr keySlot ,
	CK_MECHANISM_TYPE type
) ;

XMLSEC_CRYPTO_EXPORT int
xmlSecNssKeySlotSupportMech(
	xmlSecNssKeySlotPtr keySlot ,
	CK_MECHANISM_TYPE type
) ;


/************************************************************************
 * PKCS#11 crypto token interfaces
 *
 * A PKCS#11 slot repository will be defined internally. From the
 * repository, a user can specify a particular slot for a certain crypto
 * mechanism.
 *
 * In some situation, some cryptographic operation should act in a user
 * designated devices. The interfaces defined here provide the way. If 
 * the user do not initialize the repository distinctly, the interfaces
 * use the default functions provided by NSS itself.
 *
 ************************************************************************/
/**
 * Initialize NSS pkcs#11 slot repository
 *
 * Returns 0 if success or -1 if an error occurs.
 */
XMLSEC_CRYPTO_EXPORT int xmlSecNssSlotInitialize( void ) ;

/**
 * Shutdown and destroy NSS pkcs#11 slot repository
 */
XMLSEC_CRYPTO_EXPORT void xmlSecNssSlotShutdown() ;

/**
 * Get PKCS#11 slot handler
 * @type	the mechanism that the slot must support.
 *
 * Returns a pointer to PKCS#11 slot or NULL if an error occurs.
 *
 * Notes: The returned handler must be destroied distinctly.
 */
XMLSEC_CRYPTO_EXPORT PK11SlotInfo* xmlSecNssSlotGet( CK_MECHANISM_TYPE type ) ;

/**
 * Adopt a pkcs#11 slot with a mechanism into the repository
 * @slot:	the pkcs#11 slot.
 * @mech:	the mechanism.
 *
 * If @mech is available( @mech != CKM_INVALID_MECHANISM ), every operation with
 * this mechanism only can perform on the @slot.
 * 
 * Returns 0 if success or -1 if an error occurs.
 */
XMLSEC_CRYPTO_EXPORT int xmlSecNssSlotAdopt( PK11SlotInfo* slot, CK_MECHANISM_TYPE mech ) ;

XMLSEC_CRYPTO_EXPORT int              xmlSecNssKeysStoreAdoptKeySlot(xmlSecKeyStorePtr store,
                                                                       xmlSecNssKeySlotPtr keySlot);

XMLSEC_CRYPTO_EXPORT xmlSecKeyDataPtr xmlSecNssSymKeyDataKeyAdopt( PK11SymKey* symKey ) ;
}
